MODULE TextdateiAnwendungsdemo;
IMPORT TD:=Textdatei, TDS:=Textdatei2String, 
       TDM:=Textdatei2Matrix, D:=Display;

PROCEDURE warteAufTaste(text: ARRAY OF CHAR);
 (* lscht den Tastaturpuffer und wartet *)
VAR ch: CHAR;
BEGIN
  D.SetForeColor(255,0,0);
  D.WriteStrXY(1,25,text);
  D.SetForeColor(0,0,0);
 WHILE D.KeyPressed() DO
    ch := D.ReadKey();
  END;
  REPEAT UNTIL D.KeyPressed();
  ch := D.ReadKey();
  D.WriteLn;
END warteAufTaste;

PROCEDURE ProgMain*;
VAR st: TDS.TString;
    m: TDM.TMatrix;
    laenge,i,anzWoerter: LONGINT;
    ok: BOOLEAN;
    zeile : ARRAY 200 OF CHAR;
BEGIN
 (************ 1. Modul: Textdatei.mod Anwendungsdemo ****************)
  D.ClrScr;
  D.WriteStr("Modul-Demo Textdatei:");
  D.WriteLn;
  D.WriteStr("=====================");
  D.WriteLn;
         (* Textdatei: zeilenweise einlesen: *)
  TD.Oeffne("test.txt",TD.nurLesen,ok);
  IF ok THEN
    WHILE ok & (~TD.Dateiende()) DO
      TD.LiesZeile(zeile,ok);
      IF ok THEN
        D.WriteStr(zeile);
        D.WriteLn;
      END;
    END;
    TD.Schliesse;
  END;
    (* Demo des Schreibens ist hier nicht mglich, weil die einzelen
       Strings nicht gespeichert, nur ausgegeben wurden. *)

 (************ 2. Modul: Textdatei2String.mod Anwendungsdemo ****************)
  warteAufTaste("Bitte drcken Sie eine Taste, um das nchste Modul zu demonstrieren");
  D.ClrScr;
  D.WriteStr("Modul-Demo Textdatei2String:");
  D.WriteLn;
  D.WriteStr("============================");
  D.WriteLn;
  (* Textdatei2String: Als String einlesen: *)
  TDS.LiesTextdatei("test.txt", st, ok);
  D.WriteStr(st);
  D.WriteLn;
  D.WriteStr("und dasselbe nochmal zeichenweise: ");
  D.WriteLn;
  FOR i:=0 TO TDS.Laenge(st)-1 DO
    D.WriteChar(st[i]);
  END;
  D.WriteLn;
  D.WriteLn;
  D.WriteStr("Schreiben der Datei test2.txt:");
  D.WriteLn;
  TDS.SchreibeTextdatei("test2.txt", st, ok);
  IF ~ok THEN
    D.WriteLn;
    D.WriteStr("Fehler beim Schreiben!");
    D.WriteLn;
  END;

 (************ 3. Modul: Textdatei2Matrix.mod Anwendungsdemo ****************)
  warteAufTaste("Bitte drcken Sie eine Taste, um das nchste Modul zu demonstrieren");
  D.ClrScr;
  D.WriteStr("Modul-Demo Textdatei2Matrix:");
  D.WriteLn;
  D.WriteStr("============================");
  D.WriteLn;
  (* als Matrix einlesen: *)
  TDM.LiesTextdatei("test.txt", m, anzWoerter,ok);
  IF ok THEN
    FOR i:=0 TO anzWoerter-1 DO
      D.WriteStr(m[i]);
      D.WriteLn;
    END
    ELSE
      D.WriteLn;
      D.WriteStr("Fehler beim Lesen!");
      D.WriteLn;
  END;
  (* Matrix schreiben: *)
  TDM.SchreibeTextdatei("test3.txt",m,anzWoerter,ok);
  IF ~ok THEN
    D.WriteLn;
    D.WriteStr("Fehler beim Schreiben!");
    D.WriteLn;
  END;

  
  warteAufTaste("Bitte drcken Sie eine Taste, um das Programm zu beenden");
END ProgMain;

END TextdateiAnwendungsdemo.
